#!/usr/bin/perl

use CGI;
use LWP::Simple;
use XML::RSS;

my $cgi = new CGI;

my $station = $cgi->param('s') || "us_NY31666d";
my $channel = $cgi->param('c') || "us_COMEDY";
my $dur = $cgi->param('d') || 1;

$channel = "us_$channel" if ( $channel !~ /_/ );
$station = "us_$station" if ( $station !~ /_/ );

my $grid = "http://tv.yahoo.com/grid?lineup=$station&dur=$dur&prt=1";
my %done;
$channel =~ /([^_]*)$/;
my $nchannel = $1 || $channel;

my $rss = new XML::RSS( version => '1.0' );
my $page = get($grid);

$rss->channel(
  title => "$nchannel RSS Feed",
  description => "The latest shows for $channel",
  link => $grid,
  dc => { creator => 'John Resig <phytar@csh.rit.edu>' }
);

print "Content-type: text/xml\n\n";
while ( $page =~ /href="([^"]*?$channel\&[^"]*?)"/igs ) {
  my $url = "http://tv.yahoo.com$1&prt=1";
  $url =~ s/\s//g;

  if ( $url =~ /progutn=(\d*)/i ) {
    my $id = $1;
    unless ( exists $done{ $id } ) {
      my $show = get($url);

      if ( $show =~ /<table border=0 width="100%">.*?<td>.*?<font.*?>(.*?)<\/td>/is ) {
	my $text = $1;
	$text =~ s/<\/?font([^>]*)>//gsi;
	$text =~ s/<a([^>]*)>.*?<\/a>//gsi;
	$text =~ s/\n+/ /g;
	$text =~ /(\d{2}:\d{2}[ap]m)/i;
	my $time = $1;
	$text =~ /<b>(.*?)</i;
	my $title = $1;
        $rss->add_item( title => "$time: $title, $nchannel", 
	  description => "<![CDATA[$text]]>", link => $url );
      }
      $done{ $id } = 1;
    }
  }
}

print $rss->as_string;
